pcl::StatisticalMultiscaleInterestRegionExtraction< PointT > Class Template Reference

Class for extracting interest regions from unstructured point clouds, based on a multi scale statistical approach. More...

`#include <pcl/features/statistical_multiscale_interest_region_extraction.h>`

Inheritance diagram for pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >:

## Public Types

typedef boost::shared_ptr< std::vector< int > > | IndicesPtr
typedef boost::shared_ptr< StatisticalMultiscaleInterestRegionExtraction< PointT > > | Ptr
typedef boost::shared_ptr< const StatisticalMultiscaleInterestRegionExtraction< PointT > > | ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| StatisticalMultiscaleInterestRegionExtraction ()
| Empty constructor. More...
void | generateCloudGraph ()
| Method that generates the underlying nearest neighbor graph based on the input point cloud. More...
void | computeRegionsOfInterest (std::list< IndicesPtr > &rois)
| The method to be called in order to run the algorithm and produce the resulting set of regions of interest. More...
void | setScalesVector (std::vector< float > &scale_values)
| Method for setting the scale parameters for the algorithm. More...
std::vector< float > | getScalesVector ()
| Method for getting the scale parameters vector. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Additional Inherited Members

Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >

Class for extracting interest regions from unstructured point clouds, based on a multi scale statistical approach.

Please refer to the following publications for more details: Ranjith Unnikrishnan and Martial Hebert Multi-Scale Interest Regions from Unorganized Point Clouds Workshop on Search in 3D (S3D), IEEE Conf. on Computer Vision and Pattern Recognition (CVPR) June, 2008

Statistical Approaches to Multi-scale Point Cloud Processing Ranjith Unnikrishnan PhD Thesis The Robotics Institute Carnegie Mellon University May, 2008

Author
  Alexandru-Eugen Ichim

Definition at line 65 of file statistical_multiscale_interest_region_extraction.h.

## Member Typedef Documentation

template<typename PointT >

typedef boost::shared_ptr<const StatisticalMultiscaleInterestRegionExtraction<PointT> > pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::ConstPtr

Definition at line 70 of file statistical_multiscale_interest_region_extraction.h.

template<typename PointT >

typedef boost::shared_ptr<std::vector<int> > pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::IndicesPtr

Definition at line 68 of file statistical_multiscale_interest_region_extraction.h.

template<typename PointT >

typedef boost::shared_ptr<StatisticalMultiscaleInterestRegionExtraction<PointT> > pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::Ptr

Definition at line 69 of file statistical_multiscale_interest_region_extraction.h.

## Constructor & Destructor Documentation

template<typename PointT >

pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::StatisticalMultiscaleInterestRegionExtraction | ( |  | ) |

inline

Empty constructor.

Definition at line 74 of file statistical_multiscale_interest_region_extraction.h.

References pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::computeRegionsOfInterest(), and pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::generateCloudGraph().

## Member Function Documentation

template<typename PointT >

void pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::computeRegionsOfInterest | ( | std::list< IndicesPtr > & | rois | ) |

The method to be called in order to run the algorithm and produce the resulting set of regions of interest.

Definition at line 122 of file statistical_multiscale_interest_region_extraction.hpp.

Referenced by pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::StatisticalMultiscaleInterestRegionExtraction().

template<typename PointT >

void pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::generateCloudGraph | ( |  | ) |

Method that generates the underlying nearest neighbor graph based on the input point cloud.

Definition at line 53 of file statistical_multiscale_interest_region_extraction.hpp.

References pcl::KdTreeFLANN< PointT, Dist >::nearestKSearch(), and pcl::KdTreeFLANN< PointT, Dist >::setInputCloud().

Referenced by pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::StatisticalMultiscaleInterestRegionExtraction().

template<typename PointT >

std::vector<float> pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::getScalesVector | ( |  | ) |

inline

Method for getting the scale parameters vector.

Definition at line 98 of file statistical_multiscale_interest_region_extraction.h.

template<typename PointT >

void pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::setScalesVector | ( | std::vector< float > & | scale_values | ) |

inline

Method for setting the scale parameters for the algorithm.

Parameters

  scale_values | vector of scales to determine the size of each scaling step

Definition at line 94 of file statistical_multiscale_interest_region_extraction.h.

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/features/include/pcl/features/statistical_multiscale_interest_region_extraction.h
- /build/pcl-6_P28C/pcl-1.7.2/features/include/pcl/features/impl/statistical_multiscale_interest_region_extraction.hpp